// Copyright (c) 1999, A.H. van den Boogaard

#ifndef DIALOGS_H
#define DIALOGS_H

#include "loadbar.h"

class MyFrame;
class DrawProperties;

class ControlDialog:public wxDialog
{
   private:
      wxButton *startbutt;
      wxButton *stopbutt;
      wxButton *cancbutt;
#if wxUSE_GAUGE
      wxGauge  *gauge;
#endif
      LoadBar  *loadbar;

      bool     stop, cancel, waiting;

      DECLARE_EVENT_TABLE()

   public:
      ControlDialog( wxFrame *parent );
      ~ControlDialog(){}

      void reset();
      bool go_on(){ return !stop && !cancel; }
      bool cancelled(){ return cancel; }
      void set_waiting( bool wait ){ waiting = wait; }
      void set_gauge_percent( int percent );
      void push_convergence( float eta, bool highlight )
                  { loadbar->Push(eta,highlight); }
      void set_criterion( float c ){ loadbar->SetCriterion( c ); }

      void OnButton(wxCommandEvent& event);
};

class DrawPropDialog : public wxDialog
{
   private:
      DrawProperties *drawprops;
      MyFrame        *mainFrame;

      DECLARE_EVENT_TABLE()

   public:
      DrawPropDialog( MyFrame *parent, DrawProperties *dp,
                      const wxString& title,
                      const wxPoint& pos = wxDefaultPosition,
                      const wxSize& size = wxDefaultSize,
                      long style = wxDEFAULT_DIALOG_STYLE );
      ~DrawPropDialog(){}

      void OnOK( wxCommandEvent& event );
      void OnApply( wxCommandEvent& event );
};

#endif // DIALOGS_H
