// Copyright (c) 1999, A.H. van den Boogaard

#ifndef LOADBAR_H
#define LOADBAR_H

#include <vector>

class LoadBar:public wxWindow
{
   DECLARE_DYNAMIC_CLASS( LoadBar )
   DECLARE_EVENT_TABLE()

   private:
      struct Value:public std::pair<float,bool>
      {
         Value():std::pair<float,bool>(float(0.0),false){}
         Value(float f, bool b):std::pair<float,bool>(f,b){}
         bool operator<(const Value &b){ return first < b.first; }
      };
      bool  logscale;
      std::vector<Value> loads;
      wxCoord linewidth;
      float graph_max, graph_min;
      float crit;
      bool  use_crit;
      wxCoord height, width;
      float factor;
      
      wxCoord y_screen( float val )
          { return height - wxCoord((val-graph_min)*factor); }

   public:
      LoadBar(){}
      LoadBar(wxWindow *parent, const wxPoint& pos, const wxSize& size,
              long style=0, const char* name="loadbar" );
      ~LoadBar();
      void OnPaint( wxPaintEvent& event );
      void Push( float value, bool highlight );
      void SetLogarithmic( bool log ){ logscale = log; }
      void Reset();
      void SetCriterion( float c );
};

#endif // LOADBAR_H
