// Copyright (c) 1999, A.H. van den Boogaard

#ifndef MYDOMAIN_H
#define MYDOMAIN_H

#include "domain.h"
#include "myelmbase.h"
#include "mynodes.h"

#ifdef FT_GUI
#include "screenmap.h"
#include "graphics.h"
#endif

using std::list;

class MyDomain: public FeaTure::IncDomain<FiniteElement,MyNode>
{
   public:
      MyDomain();
      ~MyDomain();
      void print_model( std::ostream& out ) const;
      void print_title( std::ostream& out ) const;
      void print_nodes( std::ostream& out ) const;
      void print_elements( std::ostream& out ) const;
      void print_suppress( std::ostream& out ) const;
      void print_loads( std::ostream& out ) const;
      void print_node_table( std::ostream& out ) const;
      void print_results( std::ostream& out ) const;
      void print_solution( std::ostream& out ) const;
      void print_stresses( std::ostream& out ) const;
      void print_xp_stresses( std::ostream& out ) const;
      void print_reactions( std::ostream& out ) const;
      void post_file( std::ostream& out, int stepnr,
                      const FeaTure::PostProc &postproc ) const;

      void get_extremes( double &minx, double &miny, double &minz,
                         double &maxx, double &maxy, double &maxz, float dscale ) const;
#ifdef FT_GUI
      void draw_displaced( wxDC& dc, const DeviceMap& map,
                           const DrawProperties &drawprops ) const;
      void draw_nodes( wxDC& dc, const DeviceMap& map, bool numbered ) const;
      void draw_elements( wxDC& dc, const DeviceMap& map, bool numbered ) const;
#endif
};

#endif /* MYDOMAIN_H */
