// Copyright (c) 1999,2005, A.H. van den Boogaard

#include "read_mod.h"
#include "ftparser.h"
#include "ftstring.h"

int read_model( std::string file_name, MyDomain **model,
                FeaTure::Control<MyDomain> **control )
{
   if ( *model   != NULL ){ delete *model;   *model   = NULL; }
   if ( *control != NULL ){ delete *control; *control = NULL; }

   *model = new MyDomain;

   input_data in;

   in.set_file_name( file_name );

   while ( !in.interpreted_all() )
   {
      if ( in.is_new_key() )
         in.interprete_line( *model, control );
      else
         in.set_interpreted();
   }

   if ( *control == NULL ) *control = new LinearControl;

   std::string basename( get_basename( file_name ) );
   (*control)->set_basename( basename );

   return (in.nr_of_errors());
}

