// Copyright (c) 2000, A.H. van den Boogaard

#ifndef __VALNUMBR__
#define __VALNUMBR__

#include <wx/valtext.h>

class DoubleTextValidator : public wxTextValidator
{
   private:
      double   *m_doubleValue;
      wxString *m_string;

   public:
      DoubleTextValidator( double *val );
      DoubleTextValidator( const DoubleTextValidator& val );
      ~DoubleTextValidator();

      wxObject *Clone(void) const { return new DoubleTextValidator(*this); }

      bool Validate( wxWindow *parent );
      bool TransferToWindow(void);
      bool TransferFromWindow(void);
};

class IntTextValidator : public wxTextValidator
{
   private:
      int      *m_intValue;
      wxString *m_string;

   public:
      IntTextValidator( int *val );
      IntTextValidator( const IntTextValidator& val );
      ~IntTextValidator();

      wxObject *Clone(void) const { return new IntTextValidator(*this); }

      bool Validate( wxWindow *parent );
      bool TransferToWindow(void);
      bool TransferFromWindow(void);
};

#endif // __VALNUMBR__
