// Copyright (c) 1999, A.H. van den Boogaard

#ifndef COLLECT_H
#define COLLECT_H

#include "ftmatrix.h"
#include <vector>

namespace FeaTure
{

class CollectArray: public std::vector<double>
{
   private:
      mutable int next_item;

   public:
      CollectArray():std::vector<double>(){ next_item=0; }
      CollectArray( int size ):std::vector<double>(size){ next_item=0; }
      ~CollectArray(){}

      void reset(){ next_item = 0; }

      void add( double value ){ push_back( value ); }
      void add( const Vector& v );
      void add( const Matrix& m );
      
      double extract() const { return (*this)[next_item++]; }
      void extract( Vector& v ) const;
      void extract( Matrix& m ) const;
};

std::ostream& operator<<(std::ostream &s, const CollectArray &A);
std::istream& operator>>(std::istream &s, CollectArray &A);

} // namespace FeaTure

#endif /* COLLECT_H */
