// Copyright (c) 2003, A.H. van den Boogaard
//
// test program for std::abs() and std::fabs()

#include <cmath>
#include <cstdlib>
#include <iostream>

using std::cout;
using std::endl;

int main()
{
   cout.precision(7);

   double d(-3.7);
   float  f(0.1);
   int    i(10);

   cout << "std::abs(-3.7)  = " << std::abs(d) << endl;
   cout << "std::abs(0.1)   = " << std::abs(f) << endl;
   cout << "std::abs(10)    = " << std::abs(i) << endl;

   cout << "std::fabs(-3.7) = " << std::fabs(d) << endl;
   cout << "std::fabs(0.1)  = " << std::fabs(f) << endl;
//   cout << "std::fabs(10)   = " << std::fabs(i) << endl;

   if ( std::fabs( std::abs(d) - std::fabs(d) ) > 1e-10 )
      cout << endl
           << "ERROR: std::abs is still the 'int' version,"
           << " this is not ANSI-C++" << endl;
   else
      cout << "ANSI-C++ conforming: std::abs(double)==std::fabs(double)"
           << endl;

   return 0;
}
