// Copyright (c) 2004, A.H. van den Boogaard
//
// test program for FeaTure::SparseVector and FeaTure::CR_Matrix classes
// and related utility functions

#include "sprsmat.h"
#include <iomanip>
#include <iostream>

using FeaTure::CR_Matrix;
using FeaTure::Vector;
using std::cout;
using std::setw;
using std::endl;

int main()
{
   cout.precision(7);


   /*********** CONSTRUCTORS ***********/

   CR_Matrix m(3,5);
   cout << "m.num_rows() " << m.num_rows() << endl << endl;

   m.set(0,1,2.5);
   m.set(0,2,3.0);
   m.set(0,4,5.0);

   m.set(1,0,1.0);
   m.set(1,1,3.0);
   m.set(1,3,5.0);

   m.set(2,0,2.0);
   m.set(2,3,3.0);
   m.set(2,4,4.5);

   cout << "Matrix" << endl;
   cout << "0.0  2.5  3.0  0.0  5.0" << endl;
   cout << "1.0  3.0  0.0  5.0  0.0" << endl;
   cout << "2.0  0.0  0.0  3.0  4.5" << endl;

   Vector a(5);
   a[0] = 1.0;
   a[1] = 2.0;
   a[2] = 3.0;
   a[3] = 4.0;
   a[4] = 5.0;

   cout << "a" << endl << setw(5) << a << endl;

   cout << "m*a" << endl << setw(5) << m*a << endl;

   return 0;
}
